import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class Transform
{
   String input;
   String output;
   String[] pattern = {"-",">","1.","2.","3.","4.","5.","o "};
   ArrayList<String> final_version;

   boolean next = false;
   
   Transform(String input, String output){
      /** Initialisieren **/
      this.input = input;
      this.output = output;
      ArrayList<String> temp = new ArrayList<String>();

      final_version = new ArrayList<String>();
      
      readFile(temp);

      /** Liste vorbereiten und schreiben **/
      identifyBulletPoints(temp);
      prepareList(final_version);
      writeFile(final_version);
   }
   
   /**
    * Aufzhlungspunkte identifizieren und ersetzen
    * @param tmp Zu analysierende Liste
    */
   private void identifyBulletPoints(ArrayList<String> tmp){
      
      ArrayList<String> dummy= new ArrayList<String>();
      
      for(int i=0; i<tmp.size();i++){
         dummy.add(myTrim(tmp.get(i)));
         next = false;
         for(int n=0;n<pattern.length&!next;n++){
            if(dummy.get(i).indexOf(pattern[n])==0){
               if(pattern[n] == "o ")
                  final_version.add(dummy.get(i).replaceFirst(pattern[n], "* "));
               else
                  final_version.add(dummy.get(i).replaceFirst(pattern[n], "*"));
               next = true;
            }
         }
         if(!next)
            final_version.add(dummy.get(i));
      } 
   }
   
   /**
    * Entfernt Leerzeichen am Stringanfang
    * @param s Zu bearbeitender String
    * @return String ohne Leerzeichen am Anfang
    */
   private String myTrim(String s) {
      int firstIndex = 0;
    
      Character actSym = null;
      if(s.length()!=0){
         actSym = s.charAt(0);
         while (Character.isWhitespace(actSym)) {
            actSym = s.charAt(++firstIndex);
         }
      }
      return s.substring(firstIndex, s.length());
  }
   
   /**
    * Fgt separate Zeilen, die keinem Aufzhlungspunkt zugeordnet werden knnen einem 
    * davor liegenden Aufzhlungspunkt zu.   
    * @param a Liste mit Zeilen, welche analysiert werden sollen
    * @return final_version Liste, die nur aus Aufzhlungspunkten besteht
    */
    private ArrayList<String> prepareList(ArrayList<String> a){
      for(int i=0; i<a.size();i++){
         if(final_version.get(i).indexOf("*")!=0){
            if(i>0){
               final_version.set(i-1, final_version.get(i-1).concat(" "+final_version.get(i)));
               final_version.remove(i);
               prepareList(final_version);
            }
         }
      }
      return final_version;
    }
   
   /**
    * Input-File lesen und in eine Liste schreiben.
    * Leerzeilen werden nicht hinzugefgt
    * @param temp Liste, in die geschrieben werden soll
    */
   private void readFile(ArrayList<String> temp){
      String s = "";
      BufferedReader in;
      try
      {
         in = new BufferedReader(new FileReader(input));
         while((s = in.readLine()) != null){
            if(s.length()!=0)
               temp.add(s);
         }
         in.close();
      }
      catch (FileNotFoundException e)
      {
         e.printStackTrace();
      }
      catch (IOException e)
      {
         e.printStackTrace();
      }
   }
   
   /**
    * Output-File schreiben
    * @param text Liste mit Zeilen, welche in die Datei geschrieben 
    * werden sollen
    */
   private void writeFile(ArrayList<String> text){
     
      try {
        BufferedWriter b = new BufferedWriter (new FileWriter (output));
        for (int i = 0; i < text.size(); i++) {
          b.write(text.get(i).trim().replaceAll("  ", ""));
          b.newLine();
        }
        b.close();
      }
      catch (IOException e) {
        System.out.println("Fehler: "+e.toString());
      }
   }
}
