#!/usr/bin/env ruby

# Simple benchmark for the programming contest on
# aaron-mueller.de

# Aaron Mueller
# mail@aaron-mueller.de

def create_input(size)
    i = File.open("input.txt", "w")
    size.times do |c|
        i.puts " - BENCHMARK"
    end
    i.close
end

def run_program(prog)
    start = Time.now.to_f
    `#{prog} 2>&1`
    return Time.now.to_f - start
end

def benchmark(prog)
    sum = 0
    3.times do |t|
        sum += run_program(prog)
    end
    return sum/3
end

res = {:aaron => [], :thomas => [], :klaus => [], :marcel => [], :stefan => [], :wolfgang => [], :florian => [], :robert => []}
[1,5,50,100,500,1000,1500,2000,5000,10000,15000,20000,30000].each do |i|
    create_input(i)
    res[:aaron] << benchmark("ruby ../aaron.rb < input.txt")
    res[:thomas] << benchmark("bash ../thomas.sh input.txt")
    res[:klaus] << benchmark("php -f ../klaus_benchmark.php")
    res[:marcel] << benchmark("mono ../marcel_benchmark.exe input.txt out")
    res[:stefan] << benchmark("php -f ../stefan.php")
    res[:wolfgang] << benchmark("java -jar ../wolfgang.jar")
    res[:florian] << benchmark("cat input.txt | ruby ../florian.rb")
    res[:robert] << benchmark("java -jar ../robert.jar input.txt out")
    
    puts "Finish with #{i} lines"
end

res.each do |name, a|
    out = name.to_s + "\t\t: "
    a.each do |wert|
        out += wert.to_s[0..5] + ", "
    end
    puts out
end
