﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;

// Marcel Steinle
// marcel@steinle-systems.de

namespace ListParser
{
    class Program
    {
        static void Main(string[] args)
        {
            #region Declarations

            // Input and Output text
            string input = "";
            string[] intermediate;

            // Read the file through stream reader
            StreamReader sr = new StreamReader(args[0]);

            // And write it :)
            StreamWriter sw = new StreamWriter(args[1]);

            // Regex to split lines
            Regex split = new Regex("-|  o |> |[1-99].", RegexOptions.Multiline | RegexOptions.Compiled);
            Regex whitespace = new Regex(@"\s+|\s+\n|\n|\r\n");

            #endregion

            #region Read file

            // Read file
            while (!sr.EndOfStream)
                input += Convert.ToString((char)sr.Read());

            #endregion

            #region Reorganize the list

            // Copy text to array
            intermediate = split.Split(input);

            #endregion

            #region Write file

            // Write file to sw (begin at 1, 0 is empty - always)
            for (int i = 1; i < intermediate.Length; i++)
            {
                // Write every entry
                sw.WriteLine("* " + whitespace.Replace(intermediate[i], " ").Trim());
            }

            sw.Close();

            #endregion
        }
    }
}
